%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% File:         PVC:SYS-CONSTS.SL
% Description:  MIPS PSL constants needed in the compiler
% Author:       Cris Perdue
% Created:      24-Feb-84
% Modified:     27-Dec-84 (Brian Beach)
% Mode:         Lisp
% Package:      
% Status:       Experimental (Do Not Distribute)
%
% (c) Copyright 1984, Hewlett-Packard Company, all rights reserved.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Revisions:
%
%  December 8 1989 Winfried Neun , ZIB Berlin
%  initial version for Mips
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

(imports '(tags))

(fluid '(system_list*))

(setq system_list* '(MIPS Stardent unix))

(define-constant faslin-magic  199)
(define-constant faslout-magic 199)

(define-constant tagstartingbit                  0)
(define-constant tagbitlength                    5)
(define-constant infstartingbit                  5)
(define-constant infbitlength                    27)
(define-constant addressingunitsperitem          1)
(define-constant charactersperword               4)
(define-constant bitsperword                     32)
(define-constant bitsperword2                    16)
(define-constant stackdirection                  -1)
(define-constant addressingunitsperfunctioncell  1)


(define-constant maxrealregs  5)
(define-constant maxargs      15)

% At present this is the single machine-dependent character
% (for ASCII machines).  Defined here in case cross-compilation
% is being done.  Defined for the kernel in pv:scan-table.sl. /csp
(put 'eof 'charconst (char (control d)))

(define-constant stacksize             20)
(define-constant bndstksize            2000)
(define-constant compressedbinaryradix 16)
(define-constant maxtokensize          5000)
(define-constant catchstacksize        400)
(define-constant hash-table-size       18013)
(define-constant maxsymbols            15000)
%(define-constant heapsize            800000)  % These are now taken care of
%(define-constant bpssize             500000)  % by $pv/bpsheap.c

% End of file.
