%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% File:         PXK:EXTERNALS.SL
% Description:  Definitions of OpenMath foreign language functions
% Author:       Winfried Neun, ZIB , taken from Stephane Dalmas' C binding
% Created:      1-Jul-96
% Mode:         Lisp
% Package:      
% Status:       Experimental (Do Not Distribute)
%
% (c) Copyright 1996, Konrad-Zuse-Zentrum Berlin, all rights reserved.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
(off r2i)

(external-function !O!Mmake!Context  (name))   
(external-function !O!Mnamed!Context  (context))   
(external-function !O!Mcontext!Name  (context))   
(external-function !O!Mmake!Symbol  (context name))   
(external-function !O!Msymbol!Context  (symbol))   
(external-function !O!Msymbol!Name   (name))   

(external-function !O!Mmake!Device   (ii !O!MIO))
(external-function !O!M!I!O!File (file))
(external-function !O!M!I!Ofd    (fd))

(external-function !O!Mmake!Conn (n))
% (external-function !O!Mdevice!Fd (dev))
(external-function !O!Mconn!T!C!P     (conn machine port))
(external-function !O!Mconn!Unix      (conn file))
(external-function !O!Mbind!T!C!P     (conn machine port))
(external-function !O!Mbind!Unix      (conn file))

(commentoutcode % not yet
(external-function !O!M!A!S!A!Plaunch!Env (conn machine command env))
(external-function !O!M!A!S!A!Plaunch (conn machine command ))
(external-function !O!M!serve!Client  (conn ))

(external-function !O!Mconn!Close (conn))
)

(external-function !O!Mput!Int32 (dev n))
(external-function !O!Mput!Float64 (dev f))
(external-function !O!Mput!Byte!Array (dev str len))
(external-function !O!Mput!String (dev str))
(external-function !O!Mput!Var (dev name))
(external-function !O!Mput!Symbol (dev symb))
(external-function !O!Mput!App (dev))
(external-function !O!Mput!End!App (dev))
(external-function !O!Mput!Attrib (dev))
(external-function !O!Mput!End!Attrib (dev))
(external-function !O!Mput!Command (dev))
(external-function !O!Mput!End!Command (dev))
(external-function !O!Mput!Error (dev))
(external-function !O!Mput!End!Error (dev))

(external-function !O!Mget!Type (dev))
(external-function !O!Mget!Length (dev))

(external-function !O!Mget!Int32 (dev buf))
(external-function !O!Mget!Float64 (dev buff))
(external-function !O!Mget!Byte!Array (dev str))
(external-function !O!Mget!String (dev str))
(external-function !O!Mget!Var (dev str))
(external-function !O!Mget!Symbol (dev))
(external-function !O!Mget!App (dev))
(external-function !O!Mget!End!App (dev))
%(external-function !O!Mget!Attrib (dev))
%(external-function !O!Mget!End!Attrib (dev))
(external-function !O!Mget!Command (dev))
(external-function !O!Mget!End!Command (dev))
(external-function !O!Mget!Error (dev))
(external-function !O!Mget!End!Error (dev))


(on r2i)

