(de printstring (s)
  (prog (n)
        (setq n (size s))
        (for (from i 0 n 1) (do (printbyte (indx s i))))
        (printbyte 0)
        (printf "  ds 0f%n")))

(de datafileheader ()
  (dataprintf ".data%n"))

(de codefileheader ()
  (codeprintf ".text %n"))

(de printopcode (x)
  (prog (!*lower)
        (on lower)
        (prin2 x)))

(de asmoutlap (u)
  (prog (locallabels* oldout)
        (setf &links-present& (or (look-for-links u)
                                  (assoc '*Id-apply u)
                                  (assoc '*call u)))

        (setq u (append u '(("   ds  0f"))))
        (setq u (pass1lap (&fillframeholes u)))
        (setq u (lapoptreformjumps u)) % lapopt pass
        % Expand cmacros, quoted expressions
        (codeblockheader)
        (setq oldout (wrs codeout*))
        (foreach x in u do (asmoutlap1 x))
        (wrs oldout)
        (codeblocktrailer)))

(de dataalignfullword ()
  (dataprintf " ds  0f%n"))

(setq commentformat!* "/ %p %n")
(setq definedfunctioncellformat!* " dc  a(%w)%n")
(setq fullwordformat!* "        dc  a(%e)%n")

(setq *mkitemformat "      dc  al1(%e)%n     dc   al3(%e)") % ZIB
(setq exporteddeclarationformat!* ".globl  %w%n")
(setq externaldeclarationformat!* ".globl  %w%n")

(de asmpseudoprintfullword (x)
  (if (eqcar (cadr x) 'mkitem)
     (if (eqcar (caddr (cadr x)) 'idloc)
         (printf  "      dc  al1(%w)%n     dc  al3(%w)%n"
        (times2 8 (cadr (cadr x))) (findidnumber (cadr (caddr (cadr x)))))
         (printf  "      dc  al1(%w)%n     dc  al3(%w)%n"
                         (times2 8 (cadr (cadr x))) (caddr (cadr x))))
    (foreach y in (cdr x) do (printfullword y))))

(de initializesymnam (maxsymbol)

    (setq strifile (open "smain.s" 'output))

    (dataprintgloballabel (findgloballabel 'symnam))
    (for (from i 0 128 1) (do
        (dataprintf "   dc al1(32)%n   dc al3(%w)%n"
                (caddr (compileconstantxx (id2string (int2id i)))))))
    (foreach idname in (car orderedidlist*) do
        (dataprintf "   dc al1(32)%n   dc al3(%w)%n"
                (caddr (compileconstantxx (id2string idname)))))
    (channelprintf strifile "     end ")
    (close strifile)
)

(de printbyte (x)
  (printf "     dc al1(")
  (printexpression x)
  (printf ")")
  (terpri))

(setq labelformat!* "%w:%n")

(setq reservezeroblockformat!* "%w:     dc %ef'0'%n")

(setq reservedatablockformat!* "        ds %ef%n")

(setq inputsymfile!* "fuji.sym")

(setq outputsymfile!* "fuji.sym")

(de operandprintforeignentry (x)
  (prog (!*lower symnamx)
        (setq symnamx (symnam (id2int (cadr x))))
        (setq !*lower t)
        (prin2 (cadr x))))

(de *foreignlink (functionname functiontype numberofarguments)

   (let ((sequence nil))
     (setq sequence
        (append `((L (reg t1) (displacement (reg st) 4))
              (*move 200 (reg r0))
              (slr (reg st) (reg r0))
              (*wshift (reg st) -3)
              (*wshift (reg st)  3)  % double word alignment of st
              (ST (reg t1) (displacement (reg st) 4)))
                 (cond ((equal numberofarguments 0) nil)
                       (t (pnth '((*move (reg 5)  (displacement (reg r13) 80))
                                (*move (reg 4)  (displacement (reg r13) 76))
                                (*move (reg 3)  (displacement (reg r13) 72))
                                (*move (reg 2)  (displacement (reg r13) 68))
                                (*move (reg 1)  (displacement (reg r13) 64)))
                                (difference 6  numberofarguments))))))
     (setq sequence
         (append sequence
            `((L (reg r15) (lit ,(bldmsg "    dc   v(%w)" functionname)))
              (BALR (reg r14) (reg r15))
              (dc "hl2'12'"))))
     (setq sequence
         (append sequence
                    '((*move (reg r0) (reg 1))   %store return value in r1
                     )))))

(flag1 '*foreignlink 'lose)

(de kurzid (id) (prog (exp *lower *raise)
		(setq *lower t)
                (setq exp (explode2 id))
                (when (and (eq (car exp) '!u) (eq (cadr exp) '!n)
                           (eq (caddr exp) '!i) (eq (cadddr exp) '!x))
                        (setq exp (cons '!u (cddddr exp))))
                (when (and (eq (car exp) '!o) (eq (cadr exp) '!l)
                           (eq (caddr exp) '!d) )
                        (setq exp (cons '!o (cdddr exp))))
                (when (and (eq (car exp) '!e) (eq (cadr exp) '!x)
                                (greaterp (length exp) 9)
                           (eq (caddr exp) '!t)(eq (caddDr exp) '!e) )
                        (setq exp (cons '!e (pnth exp 9))))
		(off raise)
                (return (intern (compress  exp))))))

(flag1 'kurzid 'lose)

(defcmacro *ALLOC
        ((Freep) (using "*" (reg r15)))
        (       (STM (Reg r2) (reg r15) (displacement (reg r13) 16))
                (*move (plus2 200 ArgOne) (reg r0))
                (LR (reg r12) (reg r13))
                (sLR (reg r13) (reg r0))
                (st  (reg r12)  (displacement (reg r13) 4))
                (Balr (reg r3) (reg r0))
                (Using "*" (reg r3) (reg r2))
% should be optimize some day
                (la (reg r2) (displacement (reg r3) 2048))
                (la (reg r2) (displacement (reg r2) 2048))))

(DefCMacro *DeAlloc
         ((FreeP))
         (     (L  (reg r13) (displacement (reg r13) 4))
                (LM (reg r2) (reg r3) (displacement (reg r13) 16))
                (LM (reg r12) (reg r14) (displacement (reg r13) 56))))

(de *LinkE (DeAllocCount FunctionName FunctionType NumberOfArguments)
  (if (FlagP FunctionName 'ForeignFunction)
        (list (list '*ForeignLink FunctionName FunctionType NumberOfArguments)
          '(*Exit 0))
      (if (get functionname 'exitopencode)
              `((L (REG T2) (LIT (FULLWORD (idoffset SYMFNC))))
                (L (REG T2) (LIT (FULLWORD (VALUECELL ($FLUID SYMFNC)))))
                (L (REG T2) (DISPLACEMENT (REG T2) 0))
                (*DeAlloc ,DeAllocCount)
                (*JCall ,FunctionName))
      (if (get functionname 'opencode)
              `((*Call ,FunctionName)
                (*exit ,DeAllocCount))
      (if (InternallyCallableP FunctionName)
        `((l (reg r15) (lit (fullword (InternalEntry ,FunctionName))))
          (*DeAlloc ,DeAllocCount)
          (br (reg r15)))
       (if (asmp)
        `((L   (reg r0) (lit "    dc   v(SYMFNC)"))
          (*DeAlloc ,DeAllocCount)
	  (LR (reg t1) (reg r0))
          (*JCall ,FunctionName))
        `((L (reg t2) (lit (fullword (idoffset ,FunctionName))))
          (L   (reg r15) (lit (fullword (entry ,FunctionName))))
          (*DeAlloc ,DeAllocCount)
          (L   (reg r15) (indexed (reg r15) 0))
          (BR  (reg r15) ))))))))

