%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% File:         PU:OBJ-CONST.SL 
% Description:  Constants used by object package code. 
% Author:       Mike Creech, HP/CRC 
% Created:      26-Jan-84 
% Modified:     06-Mar-84 13:36:45 (Mike Creech) 
% Package:      Utilities 
%
% (c) Copyright 1987, University of Utah, all rights reserved.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Revisions:
%
% 06-Jul-84 14:56:13 (Brian Beach)
%  Changed from .LAP file to .SL file.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Other Files of Interest:
%
% The object package consists of the files:
%     objects.sl      - Top level file that loads everything necessary to use objects.
%     obj-const.lap   - List of constants used by all object modules.
%     obj-dflavor.sl  - Code for defining a new type of object.
%     obj-dmethod.sl  - Code for defining a new method.
%     obj-hash.sl     - Code for hashing scheme used for method - function association 
%                       and instance variable - evector position.
%     objinstance.sl  - Code for making instances of objects.
%     obj-lib.sl      - Library of miscellaneous functions. Some are
%                       used by two or more object package files.
%     obj-send.sl     - Code for sending messages, tracing messages, and 
%                       creating the correct method fetching scheme (at runtime
%                       in the users program).
%     
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

(defconst $MAX-COND-CLAUSES                8
	  $FAST-OBJECT-INFO-SLOT           0
	  $OBJECT-INHERITANCE-SLOT         1
	  $OBJECT-NUMBER-OF-RESERVED-SLOTS 2
	  $CODE-POINTER-SLOT               0
	  $METHOD-TABLE-SLOT               1
	  $INIT-METHOD-NAME-SLOT           2
	  $FLAVOR-NAME-SLOT                3
	  $INFO-NUMBER-OF-SLOTS            4
	  )

% End of file.


